#version 150
precision mediump float;

#define LEN 1000

uniform sampler2DRect tex0;
uniform float displace[LEN+1];
out vec4 outputColor;
in vec2 texCoordVarying;
uniform float intensity=0;
uniform float vertical=0;
uniform int WIDTH = 1280;
uniform int HEIGHT = 720;
uniform float selective = 0;
uniform float selectiveRange = 0.2;

vec3 rgb2hsv(vec4 c){
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));
    
    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

void main(){
    vec2 p = texCoordVarying;
    
    vec3 hsv = rgb2hsv(texture(tex0, texCoordVarying)); //selective
    if((hsv.x < selective - selectiveRange || hsv.x > selective + selectiveRange)
       || (hsv.y < 0.3) ){
        outputColor = texture(tex0, texCoordVarying);
        return;
    }
    
    if(vertical==0){
        p.x = p.x + int(displace[int(mod(int(p.y)+1, LEN))]*intensity);
//        p.y = p.y + int(displace[int(mod(int(p.y+WIDTH/2)+1, LEN))]*intensity) ;
        if(p.x>WIDTH)   p.x -= WIDTH;
        else if(p.x<0) p.x += WIDTH;
    }else{
        p.y = p.y + int(displace[int(mod(int(p.x)+1, LEN))]*intensity);
        if(p.y>HEIGHT)   p.y -= HEIGHT;
        else if(p.y<0) p.y += HEIGHT;
    }
    outputColor = texture(tex0, p);
}

