#version 150

#define M_PI 3.14

uniform sampler2DRect tex0;
in vec2 texCoordVarying;
out vec4 outputColor;
uniform float thresh = 0.1;
uniform float WIDTH = 1280;
uniform float HEIGHT = 720;
uniform int invert = 0;
uniform int alpha = 0;
uniform int circleMode = 1;
uniform int rectMode = 0;
uniform int blackAsVoid = 1;
uniform float minDistance = 0;

void main()
{
    vec4 c = texture(tex0, texCoordVarying);
    float x = texCoordVarying.x/WIDTH - 0.5;
    if(circleMode==1)
        x *= WIDTH/HEIGHT;
    float y = texCoordVarying.y/HEIGHT - 0.5;
    x *= 2;
    y *= 2;

    float d;
    if(rectMode==0)
        d = sqrt(x*x + y*y);
    else
        d = max(abs(x), abs(y));
    
    d = mix(-minDistance, d, d);

    float a = 1;
    if(d>=0){
    a = pow(d,(1))*M_PI/(8-thresh*4);
    a = min(a, M_PI/2);
    c *= mix(1, 0, sin(a));
    }
    
    
    
    if(invert==1){
        c = vec4(1,1,1,2) - c;
    }
    
    outputColor = vec4(c.r,c.g,c.b, blackAsVoid + (1-blackAsVoid) * (c.r+c.g+c.b)/3.0);
}
