#version 150


uniform sampler2DRect tex0;
in vec2 texCoordVarying;
out vec4 outputColor;

uniform int resolution = 25;
uniform float blurDistance = 10;
uniform float originalMix = 1;
uniform float vertical = 0;
uniform float intensity = 1;
uniform float totalMix = 1;
uniform float brightness = 1;

uniform float WIDTH = 1280;
uniform float HEIGHT = 720;
uniform float tiltShift = 0.7;
uniform float tiltRange = 0.1;


void main()
{
    vec4 c = originalMix * texture(tex0, texCoordVarying);
    vec4 bColor = vec4(0,0,0,1);
    int denom = 0;
    
    for(int i=1;i<resolution;i++){
        if(vertical!=0){
            bColor += i * texture(tex0, texCoordVarying + vec2(0.0, blurDistance * (resolution-1-i)));
            bColor += i * texture(tex0, texCoordVarying + vec2(0.0, blurDistance * -(resolution-1-i)));
        }else{
            bColor += i * texture(tex0, texCoordVarying + vec2(blurDistance * (resolution-1-i), 0.0));
            bColor += i * texture(tex0, texCoordVarying + vec2(blurDistance * -(resolution-1-i), 0.0));
        }
        denom += 2*i;
    }
    
     if(vertical!=0)
         bColor += resolution * texture(tex0, texCoordVarying + vec2(0.0, blurDistance));
     else
         bColor += resolution * texture(tex0, texCoordVarying + vec2(blurDistance, 0.0));
    
    bColor *= vec4(brightness,brightness,brightness,1);
    
    denom += resolution;
    
    float mix_ = totalMix;
    if(tiltShift>0){
        float d ;
//        if(vertical!=0)
            d =  abs((texCoordVarying.y - HEIGHT/2) / (HEIGHT/4.0));
//        else
//            d =  abs((texCoordVarying.x - WIDTH/2) / (WIDTH/4.0));
        d -= (1-tiltShift);
//        mix_ = mix(0, 1,  ;
        mix_ = d;
    }
    
    bColor /= (denom + originalMix);
    
    outputColor = bColor*vec4(1,1,1,intensity)*mix_ + (1-mix_)*c;
    
//    if(tiltShift>0)
//        outputColor = mix(outputColor, c, tiltShift*(texCoordVarying.x - WIDTH/2)/(WIDTH/2));
}