#version 150
precision mediump float;

#define PI 3.141

uniform float WIDTH = 1;
uniform float HEIGHT = 1;
uniform sampler2DRect tex0;
out vec4 outputColor;
in vec2 texCoordVarying;
uniform float sides = 3; // 0 : v mirror, 1 : h mirror
uniform float copy = 0; //multiple exposure
uniform float copyAdjust = 0; //adjust brightness
uniform float x=0,y=0;
uniform float copyBorder = 0;
uniform float scale = 1;
uniform float mirror = 0;
uniform float _mix = 1;


void main(){
    
    vec4 color = vec4(0,0,0,1);
    vec2 p = texCoordVarying - vec2(WIDTH/2,HEIGHT/2);
    
    
    float WH = HEIGHT;
    if(sides==2)
        WH = WIDTH;
    
    
    if(sides>1){
        //cart to polar
        vec2 kCoords = p;
        kCoords.x += x;
        kCoords.y += y;
        float r = length(kCoords);
        float a = atan(kCoords.y, kCoords.x);
        float tau = 2. * PI;
        
        if(copy==1){
            for(float i=0;i<sides;i+=0.5){
                float aa = mod(a - 0.5*PI, tau/sides);
                aa = abs(aa - tau/sides/2.);
                aa += 2*3.14*i/sides;
                p = r * vec2(cos(aa), sin(aa));
                    p *= scale;
                    p.x = mod(p.x+HEIGHT/2,HEIGHT)-HEIGHT/2;
                    p.y = mod(p.y+WH/2,WH)-WH/2;

                    if(copyAdjust>0)
                        color += texture(tex0, p+vec2(WIDTH/2,HEIGHT/2)) / (2*sides*copyAdjust);
                    else
                        color += texture(tex0, p+vec2(WIDTH/2,HEIGHT/2));
            }
        }else{
            float aa = mod(a - 0.5*PI, tau/sides); //works with mod(a - 0.*PI, tau/sides), better for smooth floating point sides value changes
            aa = abs(aa - tau/sides/2.);
            p = r * vec2(cos(aa), sin(aa));

            p *= scale;
            
            p.x = (mod(p.x+WIDTH/2, WIDTH) - WIDTH/2) * 1;//(
//                                                          mod((p.x) / (HEIGHT/2),2) == 0
//                                                          ? -1 : 1
//                                                          ) ;
            p.y = (mod(p.y+WH/2, WH) - WH/2) * 1;// (
//                                                         mod((p.y) / (HEIGHT/2),2) == 0
//                                                         ? -1 : 1
//                                                         ) ;

            
            
            color = texture(tex0, p+vec2(WIDTH/2,HEIGHT/2));
        }
    }else{
        p *= scale;

        vec2 p2;
        if(sides < 1){ //mirror
            if(copy==1){
                p2 = vec2(-p.x, p.y);
                if(mirror==1)
                    p2.y = -p2.y;
                if(scale>1){
                    p.x = mod(p.x+HEIGHT/2,HEIGHT)-HEIGHT/2;
                    p.y = mod(p.y+HEIGHT/2,HEIGHT)-HEIGHT/2;
                    p2.x = mod(p2.x+HEIGHT/2,HEIGHT)-HEIGHT/2;
                    p2.y = mod(p2.y+HEIGHT/2,HEIGHT)-HEIGHT/2;
                }
                color = (texture(tex0, p + vec2(x,y)+vec2(WIDTH/2,HEIGHT/2)) + texture(tex0, p2  + vec2(WIDTH/2,HEIGHT/2)));
                if(copyAdjust==1)
                    color /= 2;
            }else{
                if(p.x >= 0){
                    p.x = - p.x;
                    if(mirror==1)
                        p.y = -p.y;
                }
                if(scale>1){
                    p.x = mod(p.x+HEIGHT/2,HEIGHT)-HEIGHT/2;
                    p.y = mod(p.y+HEIGHT/2,HEIGHT)-HEIGHT/2;
                    p2.x = mod(p2.x+HEIGHT/2,HEIGHT)-HEIGHT/2;
                    p2.y = mod(p2.y+HEIGHT/2,HEIGHT)-HEIGHT/2;
                }
                color = texture(tex0, p + vec2(WIDTH/2,HEIGHT/2));
            }
            
        }else{
            
        if(sides==1){ //mirror
            if(copy==1){
                p2 = vec2(p.x, - p.y);
                if(mirror==1)
                    p2.x = -p2.x;
                if(scale>1){
                    p.x = mod(p.x+HEIGHT/2,HEIGHT)-HEIGHT/2;
                    p.y = mod(p.y+HEIGHT/2,HEIGHT)-HEIGHT/2;
                    p2.x = mod(p2.x+HEIGHT/2,HEIGHT)-HEIGHT/2;
                    p2.y = mod(p2.y+HEIGHT/2,HEIGHT)-HEIGHT/2;
                }
                color = texture(tex0, p + vec2(WIDTH/2,HEIGHT/2)) + texture(tex0, p2 + vec2(WIDTH/2,HEIGHT/2));
                if(copyAdjust==1)
                    color /= 2;
            }else{
                if(p.y >= 0){
                    p.y = -p.y;
                    if(mirror==1)
                        p.x = -p.x;
                }
                if(scale>1){
                    p.x = mod(p.x+HEIGHT/2,HEIGHT)-HEIGHT/2;
                    p.y = mod(p.y+HEIGHT/2,HEIGHT)-HEIGHT/2;
                }
                color = texture(tex0, p + vec2(WIDTH/2,HEIGHT/2));
            }
        }
        }
    }
    
    outputColor = mix(texture(tex0, texCoordVarying), color, _mix);
}
