#version 150

uniform sampler2DRect tex0;
in vec2 texCoordVarying;
out vec4 outputColor;
uniform float thresh = 0.1;
uniform float hue = 0.3;

vec3 rgb2hsv(vec4 c){
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));
    
    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

void main()
{
    vec4 c = texture(tex0, texCoordVarying);
    vec3 hsv = rgb2hsv(c);
    
    float mean = abs(hsv.x - hue);
    
   if(hsv.x - hue - thresh/2.0 < 0  &&
        hsv.x - hue + thresh/2.0 > 0
        && (hsv.y > 0.20 && hsv.z > 0)
       )
        outputColor = vec4(0,0,0,1);
    else{
    outputColor = vec4(c.r,c.g,c.b,c.a);
    }
}
