#version 150

uniform sampler2DRect tex0;
in vec2 texCoordVarying;
out vec4 outputColor;
uniform float WIDTH = 1280;
uniform float HEIGHT = 720;
uniform float t = 0; // en faire un décalage. valeur <0 : decalage + invertSense
uniform float resolution = 4;

uniform int inv = 0;
uniform float _border = 0.05;
uniform int sense = 1;


uniform float anim = 0;
uniform int keepBackground = 0;

///SPACE
uniform float halfCircle = 0;
uniform float zoom = 0;

void main()
{
    vec2 p = texCoordVarying-vec2(WIDTH/2,HEIGHT/2);
    
    vec2 circleCoord = p;
    if(halfCircle==1)
        circleCoord.y -= HEIGHT/2;
    float d = length(circleCoord);
    float a = atan(circleCoord.y, circleCoord.x);
    
    if(d<HEIGHT/(2-zoom)){
        int index =  int(resolution*d/(HEIGHT/2));
        
        if(_border>0 && resolution*d/(HEIGHT/2) - index < _border)
            outputColor = vec4(0,0,0,1);
        else{
            
            float da = 1*t/300.0 * 3.14*2 * (index+1) / (10);
            
            if(sense>0)
                da *=  (index%2==0 ? -1 : 1);
            
            a = mod(a + da, 2*3.14);
            {
                p.x = d*cos(a);
                p.y = d*sin(a);
                
                p/=(1+zoom);
            
                
                outputColor = texture(tex0, p+vec2(WIDTH/2, HEIGHT/2));
                if(inv>0 && index%2==1)
                    outputColor = vec4(1-outputColor.x, 1-outputColor.y, 1-outputColor.z, outputColor.w);
            }
        }
    }else{
        if(keepBackground==1){
            outputColor = texture(tex0, texCoordVarying); //bypass
        }else{
        outputColor = vec4(0,0,0,1);
        }
    }
    
}