#version 150

uniform sampler2DRect tex0;
in vec2 texCoordVarying;
out vec4 outputColor;
uniform float thresh = 0.1;
uniform float mode = 0;
uniform float WIDTH = 1280;
uniform float HEIGHT = 720;

void main()
{
    vec4 c = texture(tex0, texCoordVarying);
    float x = texCoordVarying.x/WIDTH - 0.5;
    
    float y = texCoordVarying.y/HEIGHT - 0.5;
    x *= 2;
    y *= 2;
    
    if(mode==0 || mode==1 || mode==2){ //circle
        float d;
        
        if(mode==0){
            x *= WIDTH/HEIGHT;
            d = sqrt(x*x + y*y);
        }else{
            if(mode==1)
                d = (x - 1)/2.0;
            if(mode==2)
                d = (y - 1)/2.0;
        }
    
        bool on = true;
        if(abs(d) > abs(thresh)){
            on = false;
        }
        
        if(thresh < 0)
            on = !on;
        
        if(!on){
            outputColor = vec4(0,0,0,1);
        }else{
            outputColor = vec4(c.r,c.g,c.b,1);
        }
    }
}
