#version 150

uniform sampler2DRect tex0;
in vec2 texCoordVarying;
out vec4 outputColor;
uniform float WIDTH = 1280;
uniform float HEIGHT = 720;
uniform float da = 0.75; // 0.75:centered : 0.25 : out of phase (cool for cinema)
uniform float dx = 0;
uniform float intensity=1;
uniform float n = 5;

void main()
{
    
    
    vec4 color = vec4(0,0,0,1);
    vec2 p = (texCoordVarying - vec2(WIDTH/2,HEIGHT/2)) / vec2(WIDTH/2, HEIGHT/2);
    vec2 pn = (texCoordVarying - vec2(WIDTH/2,HEIGHT/2)) / vec2(HEIGHT/2, HEIGHT/2);
    
    float r = length(pn);
    float tau = 2. * 3.1416;
    
    float level = int( length(pn) * intensity);
    
    float sides = level*n;
    
    if(sides<1.1){
        p *= intensity;
//    if((abs(p.x)<1 && abs(p.y)<1))
                color = texture(tex0, p*vec2(WIDTH/2, HEIGHT/2)+vec2(WIDTH/2,HEIGHT/2));
    }else{
//        sides = 4;
        float scale = sides;
        
        float a = atan(p.y, p.x);
        
        vec2 offset = level/2.0 * vec2(cos(-a), sin(-a));
        
        a = mod(a, tau / sides);
        
        p -= offset;

        p *= scale*intensity;

        
//        if(scale>1)
//        p *= 1;
        
        if((abs(p.x)<1 && abs(p.y)<1))
            color = texture(tex0, (p) * vec2(WIDTH/2, HEIGHT/2) + vec2(WIDTH/2,HEIGHT/2));
//        color = vec4(a/tau,0,0,1);
    }
    

    outputColor = color;

}