#version 150

uniform sampler2DRect tex0;
in vec2 texCoordVarying;
out vec4 outputColor;
uniform float WIDTH = 1280;
uniform float HEIGHT = 720;
uniform float t = 0; // en faire un décalage. valeur <0 : decalage + invertSense
uniform float resolution = 4;

uniform int inv = 1;
uniform float _border = 0.01;
uniform int sense = 1;

uniform float anim = 0;

void main()
{
    vec2 p = texCoordVarying-vec2(WIDTH/2,HEIGHT/2);
    int invertColor = 0;
    
    if(abs(p.x)<HEIGHT/2 && abs(p.y)<HEIGHT/2){
        
        float d = length(p);
        
        //        if(d<HEIGHT/2){
        
        float a = atan(p.y, p.x);
        
        //    int index =  int(resolution*d/(HEIGHT/2));
        
        for(int i=0;i<resolution;i++){ //OPT change by index search (congruence math)
            
            //        float _max = HEIGHT/(i+1); //logarithmic
            //        float _min = HEIGHT/(i+2);
            float _max = (i)* HEIGHT/resolution;
            float _min = (i+1)*HEIGHT/resolution;
            
            //        float _max = 0.5*HEIGHT*(index+2)/resolution;
            //        float _min = 0.5*HEIGHT*(index+1)/resolution;
            
            if((abs(p.x)<_max || abs(p.y)<_max) && (abs(p.x)>_min || abs(p.y)>_min)
               //           && (abs(abs(p.x) - abs(p.y))< _min)
               ){
                //            if((abs(p.x)<_max ) && (abs(p.x)>_min )){
                //        d += 0.05*HEIGHT/resolution; // multiplication is also OK
                a += 3.14/2 * i;
                invertColor = (inv>0 && i%2==1) ? 1 : 0;
//                break;
            }
        }
        
        p.x = d*cos(a);
        p.y = d*sin(a);
        
        outputColor = texture(tex0, p+vec2(WIDTH/2, HEIGHT/2));
        if(invertColor>0)
            outputColor = vec4(1-outputColor.x, 1-outputColor.y, 1-outputColor.z, outputColor.w);
    }else
        outputColor = vec4(0,0,0,1);
    
}