#version 150
precision mediump float;

#define LEN 10

uniform sampler2DRect tex0;
out vec4 outputColor;
in vec2 texCoordVarying;
uniform float WIDTH = 3545;
uniform float HEIGHT = 1200;
uniform float SRC_WIDTH = 1280;
uniform float SRC_HEIGHT = 720;
uniform float nb = 6;
uniform float pos[LEN] = float[LEN](0, 0.8, 0.3, 0.6, 0.4, 0.1, 0.7, 0.2, 0.4, 0);
uniform float inv[LEN] = float[LEN](0, 1, 0, 1, 0, 1, 0, 1, 0, 1);

void main(){
    vec2 p = texCoordVarying;
    
    int index = int(nb * p.x / WIDTH);
    
    float offset = index%2 * 0.5 + index / (nb*1.5) * SRC_WIDTH;
    p.x = offset + p.x - index * WIDTH / nb;

    if(inv[index] == 1)
        p.y = HEIGHT - p.y;
    
    outputColor = texture(tex0, p);
}
